

import useRouter from '@/utils/hooks/useRouter'
import { useMemo } from 'react'
import { useModel } from '@/store'
import Spin from "@/components/Spin";

import LoginModel from '@/components/LoginModel'
import useLogin from '@/utils/hooks/useLogin'



export default (Child) => (props) => {
  const { person } = useModel('userData')
  const router = useRouter()
  const { loginVisible } = useLogin()

  // 确保执行过 login 方法，拿到了 person
  const isLoged = useMemo(() => !!person?.personId, [person?.personId])

  return (
    <>
      {!isLoged && <Spin />}
      {
        isLoged && !loginVisible && <Child {...props} router={router} />
      }
      {
        isLoged && loginVisible && <LoginModel isLoginVisible={loginVisible} path={router.path} />
      }
    </>
  )


}