import { View, Form, Textarea } from "@tarojs/components"
import Taro from "@tarojs/taro"
import CustomNav from "@/components/CustomNav"
import ButtontWX from '@/components/ButtontWX'
import { addressSave, addressUpdate } from "@/services/address"
import withLayout from '@/layouts'
import './style.less'

export default withLayout((props) => {

  const $instance = Taro.getCurrentInstance()
  const { addressId, address } = $instance.router.params

  const formSubmit = e => {
    const value = e?.detail?.value
    if (addressId) {
      addressUpdate(addressId, { address: value.address }).then((res) => {
        Taro.showToast({
          title: '地址修改成功',
          icon: 'success',
          duration: 2000
        }).then(() => {
          setTimeout(() => {
            Taro.navigateBack({
              delta: 1
            })
          }, 1000)
        })
      })
    } else {
      addressSave({ address: value.address }).then((e) => {
        Taro.showToast({
          title: '地址添加成功',
          icon: 'success',
          duration: 2000
        }).then(() => {
          setTimeout(() => {
            Taro.navigateBack({
              delta: 1
            })
          }, 1000)
        })
      })
    }
  }
  const formReset = e => {
    console.log(e)
  }

  return (
    <View className='page-index'>
      <View className='index-navbar'>
        <CustomNav title='添加地址' />
      </View>

      <View className='index-container form-content'>
        <Form onSubmit={formSubmit} onReset={formReset} >
          <View className='example-body'>
            <View>详细地址：</View>
            <Textarea name='address' value={address} className='aTextareaCentent' placeholder='请输入地址信息' />
          </View>
          <View className='buton-bottom'>
            <ButtontWX formType='submit' butText='保存' butWidth={315} butHeight={49} butFontSize={16} butBorderRadius={49} />
          </View>
        </Form>

      </View>
    </View>
  )
})