import { View, Image } from "@tarojs/components"
import CustomNav from "@/components/CustomNav"
import decorate from "@/assets/icons/comm/decorate.png"
import withLayout from '@/layouts'
import Taro from "@tarojs/taro"

import { useEffect, useState } from "react"
import { getNewsInfo } from "@/services/news"
import InfoImgaText from "./InfoImgaText"



import './style.less'



export default withLayout((props) => {

  const $instance = Taro.getCurrentInstance()
  const { id } = $instance.router.params
  const [newInfo, setNewInfo] = useState()
  useEffect(() => {
    if (id) {
      getNewsInfo(id).then((res) => {
        setNewInfo(res)

      })
    }
  }, [])

  return (
    <View className='page-index'>
      <View className='index-navbar'>
        <CustomNav title='农业资讯' />
      </View>
      <scroll-view scrollY style='height: 100%;' >
        <View>
          <View className='articleTitle-box-sta'>
            <Image src={decorate} />
            <View >{newInfo?.title}</View>
            <Image src={decorate} />
          </View>
          <View style={{ padding: '25px 15px 130px 15px' }}>
            {
              newInfo?.contentList.map((item, index) => {
                return (
                  <InfoImgaText item={item} />

                )

              })
            }

          </View>


        </View>
      </scroll-view>
    </View>
  )
})
