import Taro from '@tarojs/taro'
import { useState } from 'react'
import { View, Input, Image } from '@tarojs/components'
import withLayout from '@/layouts'
import CustomNav from '@/components/CustomNav'
import CarsListContent from "@/components/CarsListContent"
import { useThrottle } from '@/utils/codeSegment'
import { getMachinery } from '@/services/homes'
import searchs from '@/assets/homesImgaes/searchs.png'//搜索图片
import './style.less'

export default withLayout((props) => {
  const $instance = Taro.getCurrentInstance()
  const { id, location } = $instance.router.params

  const [carsList, setCarsList] = useState([])
  //节流 搜索
  const handlerSearch = useThrottle((e) => {
    const { value } = e?.detail
    getMachinery(location, { q: value, location: location }).then((res) => {
      setCarsList(res.records)
    })
  }, 1000)

  return (
    <View className='page-index'>
      <View className='index-navbar'>
        <CustomNav title='搜索' />
      </View>
      <View className='searchClass-jieguoye'>
        <Input type='text' onInput={handlerSearch} placeholder='搜索关键字查询' />
        <Image src={searchs} />
      </View>
      <scroll-view scrollY style='height: 100%;' >
        <View className='CarsListContent'>
          <CarsListContent carsList={carsList} />
        </View>
      </scroll-view>
    </View>
  )
})